Stacked Column 100% in JavaScript

Using ApexCharts with JavaScript

This Stacked Column 100% example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Mobile',
      data: [44, 55, 41, 67, 22, 43, 21, 49],
    },
    {
      name: 'Desktop',
      data: [13, 23, 20, 8, 13, 27, 33, 12],
    },
    {
      name: 'Tablet',
      data: [11, 17, 15, 15, 21, 14, 15, 13],
    },
  ],
  chart: {
    type: 'bar',
    height: 350,
    stacked: true,
    stackType: '100%',
  },
  responsive: [
    {
      breakpoint: 480,
      options: {
        legend: {
          position: 'bottom',
          offsetX: -10,
          offsetY: 0,
        },
      },
    },
  ],
  title: {
    text: 'Traffic Share by Device',
    align: 'left',
  },
  xaxis: {
    categories: [
      '2024 Q1',
      '2024 Q2',
      '2024 Q3',
      '2024 Q4',
      '2025 Q1',
      '2025 Q2',
      '2025 Q3',
      '2025 Q4',
    ],
  },
  fill: {
    opacity: 1,
  },
  legend: {
    position: 'right',
    offsetX: 0,
    offsetY: 50,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Mobile',
        data: [44, 55, 41, 67, 22, 43, 21, 49],
      },
      {
        name: 'Desktop',
        data: [13, 23, 20, 8, 13, 27, 33, 12],
      },
      {
        name: 'Tablet',
        data: [11, 17, 15, 15, 21, 14, 15, 13],
      },
    ],
    options: {
      chart: {
        type: 'bar',
        height: 350,
        stacked: true,
        stackType: '100%',
      },
      responsive: [
        {
          breakpoint: 480,
          options: {
            legend: {
              position: 'bottom',
              offsetX: -10,
              offsetY: 0,
            },
          },
        },
      ],
      title: {
        text: 'Traffic Share by Device',
        align: 'left',
      },
      xaxis: {
        categories: [
          '2024 Q1',
          '2024 Q2',
          '2024 Q3',
          '2024 Q4',
          '2025 Q1',
          '2025 Q2',
          '2025 Q3',
          '2025 Q4',
        ],
      },
      fill: {
        opacity: 1,
      },
      legend: {
        position: 'right',
        offsetX: 0,
        offsetY: 50,
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bar"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Stacked Column 100% in Vue

Using ApexCharts with Vue

This Stacked Column 100% example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bar"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Mobile',
          data: [44, 55, 41, 67, 22, 43, 21, 49],
        },
        {
          name: 'Desktop',
          data: [13, 23, 20, 8, 13, 27, 33, 12],
        },
        {
          name: 'Tablet',
          data: [11, 17, 15, 15, 21, 14, 15, 13],
        },
      ],
      chartOptions: {
        chart: {
          type: 'bar',
          height: 350,
          stacked: true,
          stackType: '100%',
        },
        responsive: [
          {
            breakpoint: 480,
            options: {
              legend: {
                position: 'bottom',
                offsetX: -10,
                offsetY: 0,
              },
            },
          },
        ],
        title: {
          text: 'Traffic Share by Device',
          align: 'left',
        },
        xaxis: {
          categories: [
            '2024 Q1',
            '2024 Q2',
            '2024 Q3',
            '2024 Q4',
            '2025 Q1',
            '2025 Q2',
            '2025 Q3',
            '2025 Q4',
          ],
        },
        fill: {
          opacity: 1,
        },
        legend: {
          position: 'right',
          offsetX: 0,
          offsetY: 50,
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Stacked Column 100% in Angular

Using ApexCharts with Angular

This Stacked Column 100% example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Mobile',
              data: [44, 55, 41, 67, 22, 43, 21, 49],
            },
            {
              name: 'Desktop',
              data: [13, 23, 20, 8, 13, 27, 33, 12],
            },
            {
              name: 'Tablet',
              data: [11, 17, 15, 15, 21, 14, 15, 13],
            },
          ],
          chart: {
            type: 'bar',
            height: 350,
            stacked: true,
            stackType: '100%',
          },
          responsive: [
            {
              breakpoint: 480,
              options: {
                legend: {
                  position: 'bottom',
                  offsetX: -10,
                  offsetY: 0,
                },
              },
            },
          ],
          title: {
            text: 'Traffic Share by Device',
            align: 'left',
          },
          xaxis: {
            categories: [
              '2024 Q1',
              '2024 Q2',
              '2024 Q3',
              '2024 Q4',
              '2025 Q1',
              '2025 Q2',
              '2025 Q3',
              '2025 Q4',
            ],
          },
          fill: {
            opacity: 1,
          },
          legend: {
            position: 'right',
            offsetX: 0,
            offsetY: 50,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}